SELECT SO.LINK as Project, Release = 67584, Fix = (select max(S1.Fix) from S_RELEASE S1 WHERE S1.release = 67584)
INTO #tmpRelease
FROM S_OBJECTS SO
WHERE RTRIM(LTRIM(SO.CODE))='PROJECT'

BEGIN TRAN
	Select SFU.Name, SR.ID as Release, SFU.Path, SFU.CreateDate, SFU.FileSize, SFU.ID as oldID
	INTO #tmpFiles
	From S_FILES_U SFU INNER JOIN S_RELEASE SR ON 1=1
		INNER JOIN #tmpRelease T ON T.Release = SR.Release AND T.FIX = SR.FIX

	DELETE FROM S_FILES
	FROM #tmpFiles T WHERE T.NAME = S_FILES.NAME
	
	
	INSERT INTO S_FILES(Name, Release, Path, CreateDate, FileSize)
	SELECT Name, Release, Path, CreateDate, FileSize
	From #tmpFiles
	
	
	INSERT INTO S_FILEPARTS(File_ID, ORDERS, BODY)
	Select SF.ID, SPU.Orders, convert(varchar(8000), SPU.Body)
	From S_FILES SF, S_FILEPARTS_U SPU, #tmpFiles TF
	Where SF.Release = TF.Release
		AND SF.Name = TF.Name
		AND SPU.File_ID = TF.oldID

	IF EXISTS(select * from s_files F
		where F.Filesize <> (select sum(datalength(body)) from s_fileparts where file_id = F.id))
	BEGIN 
		ROLLBACK
		raiserror('     !   !',11,1)
		RETURN
	END
WHILE @@TRANCOUNT > 0
	COMMIT TRAN

Drop Table #tmpFiles
Drop Table #tmpRelease
GO

/*******************************/

IF (SELECT COUNT(*) FROM dbo.OKPD) < 37000
BEGIN

	IF OBJECT_ID ('TEMPDB..#REC','U') IS NOT NULL
		DROP TABLE #REC

	CREATE TABLE #REC (LINK INT)

	INSERT INTO #REC (LINK)
	SELECT OKPD FROM dbo.FINANSE_CONTRACT WHERE OKPD IS NOT NULL	
	UNION SELECT OKPD FROM dbo.GZ_DOC_TABLE WHERE OKPD IS NOT NULL
	UNION SELECT OKPD FROM dbo.GZ_PLAN_TABLE WHERE OKPD IS NOT NULL	
	UNION SELECT LINK_OKPD FROM dbo.NOMENCLATURE WHERE LINK_OKPD IS NOT NULL

	IF not exists(select * from sysobjects where id = object_id('[dbo].[OKPD_OLD]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	CREATE TABLE [dbo].[OKPD_OLD] (
		[LINK] int,
		[LINK_SELF] int,
		[CODE] char(12),
		[NAME] varchar(254),
		[UM] int,
		[USED] bit,
		[LINK2] INT)

	INSERT INTO [dbo].[OKPD_OLD] (LINK, LINK_SELF, CODE, NAME, UM, USED)
	SELECT T.LINK, T.LINK_SELF, T.CODE, T.NAME, T.UM, T.USED 
	FROM 
		#REC R
		INNER JOIN dbo.OKPD T ON R.Link = T.LINK

	--,    
	UPDATE A SET A.LINK2 = B.LINK
	FROM
		[dbo].[OKPD_OLD] A
		INNER JOIN [dbo].[OKPD_U] B ON A.CODE = B.CODE

	DECLARE @Q NVARCHAR(4000)
	
	SET @Q = '
	IF EXISTS (SELECT * FROM dbo.sysconstraints WHERE constid =  object_id(''dbo.[FK_FINANSE_CONTRACT_OKPD]''))
	ALTER TABLE [dbo].[FINANSE_CONTRACT] DROP CONSTRAINT [FK_FINANSE_CONTRACT_OKPD]
	'
	EXEC SP_EXECUTESQL @Q 

	SET @Q = '
	IF EXISTS (SELECT * FROM dbo.sysconstraints WHERE constid =  object_id(''dbo.[FK_GZ_NOT_CONTRACT_OKPD]''))
	ALTER TABLE [dbo].[gz_doc_table] DROP CONSTRAINT [FK_GZ_NOT_CONTRACT_OKPD]
	'
	EXEC SP_EXECUTESQL @Q 

	SET @Q = '
	IF EXISTS (SELECT * FROM dbo.sysconstraints WHERE constid =  object_id(''dbo.[FK_GZ_PLAN_TABLE_OKPD]''))
	ALTER TABLE [dbo].[GZ_PLAN_TABLE] DROP CONSTRAINT [FK_GZ_PLAN_TABLE_OKPD]
	'
	EXEC SP_EXECUTESQL @Q 

	SET @Q = '
	IF EXISTS (SELECT * FROM dbo.sysconstraints WHERE constid =  object_id(''dbo.[FK_NOMENCLATURE_OKPD]''))
	ALTER TABLE [dbo].[NOMENCLATURE] DROP CONSTRAINT [FK_NOMENCLATURE_OKPD]
	'
	EXEC SP_EXECUTESQL @Q 

	SET @Q = '
	IF EXISTS (SELECT * FROM dbo.sysconstraints WHERE constid =  object_id(''dbo.[FK_OKPD_OKPD]''))
	ALTER TABLE [dbo].[OKPD] DROP CONSTRAINT [FK_OKPD_OKPD]
	'
	EXEC SP_EXECUTESQL @Q 

	SET @Q = '
	--  
	IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N''dbo.[OKPD_XDELETE]'') AND OBJECTPROPERTY(id, N''IsTrigger'') = 1)
	DROP TRIGGER dbo.[OKPD_XDELETE]
	'
	EXEC SP_EXECUTESQL @Q 

	SET @Q = '
	DELETE dbo.OKPD
	'
	EXEC SP_EXECUTESQL @Q 

	SET @Q = '
	-- 
	SET IDENTITY_INSERT OKPD ON 

	INSERT INTO dbo.OKPD ([LINK],[LINK_SELF],[CODE],[NAME],[UM],[USED])
	SELECT [LINK],[LINK_SELF],[CODE],[NAME],[UM],[USED] FROM dbo.OKPD_U

	SET IDENTITY_INSERT OKPD OFF 

	DECLARE @LINK INT
	SET @LINK = ISNULL((SELECT MAX(LINK) FROM dbo.OKPD),0)

	DBCC CHECKIDENT (OKPD, RESEED, @LINK)
	'
	EXEC SP_EXECUTESQL @Q 

	SET @Q = '
	--       
	UPDATE A SET A.OKPD = B.LINK2 FROM [dbo].[FINANSE_CONTRACT] A INNER JOIN [dbo].[OKPD_OLD] B ON B.LINK = A.OKPD
	UPDATE A SET A.OKPD = B.LINK2 FROM [dbo].[gz_doc_table] A INNER JOIN [dbo].[OKPD_OLD] B ON B.LINK = A.OKPD
	UPDATE A SET A.OKPD = B.LINK2 FROM [dbo].[GZ_PLAN_TABLE] A INNER JOIN [dbo].[OKPD_OLD] B ON B.LINK = A.OKPD	
	UPDATE A SET A.[LINK_OKPD] = B.LINK2 FROM [dbo].[NOMENCLATURE] A INNER JOIN [dbo].[OKPD_OLD] B ON B.LINK = A.[LINK_OKPD]		
	UPDATE A SET A.[LINK_SELF] = B.LINK2 FROM [dbo].[OKPD] A INNER JOIN [dbo].[OKPD_OLD] B ON B.LINK = A.[LINK_SELF]
	'
	EXEC SP_EXECUTESQL @Q 

	SET @Q = '
	-- ,         
	IF COLUMNPROPERTY(object_id(''[dbo].[OKPD]''), ''LINK2'', ''AllowsNull'') is NULL
	   ALTER TABLE [dbo].[OKPD] ADD [LINK2] int
	'
	EXEC SP_EXECUTESQL @Q 

	SET @Q = '
	IF EXISTS (SELECT * FROM dbo.OKPD_OLD WHERE LINK2 IS NULL)
	BEGIN
		-- ,          
		INSERT INTO [dbo].[OKPD] ([CODE],[NAME]) VALUES (''***'',''  '')

		DECLARE @OLD INT
		SET @OLD = (SELECT TOP 1 LINK FROM [dbo].[OKPD] WHERE CODE = ''***'')

		INSERT INTO [dbo].[OKPD] ([LINK_SELF], [CODE],[NAME],[UM],[USED],[LINK2])
		SELECT @OLD, CODE, NAME, UM, USED, LINK FROM dbo.OKPD_OLD WHERE LINK2 IS NULL

		UPDATE A SET A.OKPD = B.LINK FROM [dbo].[FINANSE_CONTRACT] A INNER JOIN [dbo].[OKPD] B ON B.LINK2 = A.OKPD
		UPDATE A SET A.OKPD = B.LINK FROM [dbo].[gz_doc_table] A INNER JOIN [dbo].[OKPD] B ON B.LINK2 = A.OKPD
		UPDATE A SET A.OKPD = B.LINK FROM [dbo].[GZ_PLAN_TABLE] A INNER JOIN [dbo].[OKPD] B ON B.LINK2 = A.OKPD	
		UPDATE A SET A.[LINK_OKPD] = B.LINK FROM [dbo].[NOMENCLATURE] A INNER JOIN [dbo].[OKPD] B ON B.LINK2 = A.[LINK_OKPD]		
		UPDATE A SET A.[LINK_SELF] = B.LINK FROM [dbo].[OKPD] A INNER JOIN [dbo].[OKPD] B ON B.LINK2 = A.[LINK_SELF]			
		
	END	
	'
	EXEC SP_EXECUTESQL @Q 

	SET @Q = '
	IF COLUMNPROPERTY(object_id(''[dbo].[OKPD]''), ''LINK2'', ''AllowsNull'') is NOT NULL
	   ALTER TABLE [dbo].[OKPD] DROP COLUMN [LINK2]
	'
	EXEC SP_EXECUTESQL @Q 

	SET @Q = '
	IF NOT EXISTS (SELECT * FROM dbo.sysconstraints WHERE constid =  object_id(''dbo.[FK_FINANSE_CONTRACT_OKPD]''))
	ALTER TABLE [dbo].[FINANSE_CONTRACT] WITH NOCHECK 
	ADD CONSTRAINT [FK_FINANSE_CONTRACT_OKPD] FOREIGN KEY ([OKPD]) REFERENCES [dbo].[OKPD] ([LINK])
	ALTER TABLE [dbo].[FINANSE_CONTRACT] NOCHECK CONSTRAINT [FK_FINANSE_CONTRACT_OKPD]
	'
	EXEC SP_EXECUTESQL @Q 

	SET @Q = '
	IF  NOT EXISTS (SELECT * FROM dbo.sysconstraints WHERE constid =  object_id(''dbo.[FK_GZ_NOT_CONTRACT_OKPD]''))
	ALTER TABLE [dbo].[gz_doc_table] WITH NOCHECK 
	ADD CONSTRAINT [FK_GZ_NOT_CONTRACT_OKPD] FOREIGN KEY ([OKPD]) REFERENCES [dbo].[OKPD] ([LINK])
	ALTER TABLE [dbo].[gz_doc_table] NOCHECK CONSTRAINT [FK_GZ_NOT_CONTRACT_OKPD]
	'
	EXEC SP_EXECUTESQL @Q 

	SET @Q = '
	IF  NOT EXISTS (SELECT * FROM dbo.sysconstraints WHERE constid =  object_id(''dbo.[FK_GZ_PLAN_TABLE_OKPD]''))
	ALTER TABLE [dbo].[GZ_PLAN_TABLE] 
	ADD CONSTRAINT [FK_GZ_PLAN_TABLE_OKPD] FOREIGN KEY ([OKPD]) REFERENCES [dbo].[OKPD] ([LINK])
	'
	EXEC SP_EXECUTESQL @Q 

	SET @Q = '
	IF  NOT EXISTS (SELECT * FROM dbo.sysconstraints WHERE constid =  object_id(''dbo.[FK_NOMENCLATURE_OKPD]''))
	ALTER TABLE [dbo].[NOMENCLATURE] WITH NOCHECK 
	ADD CONSTRAINT [FK_NOMENCLATURE_OKPD] FOREIGN KEY ([LINK_OKPD]) REFERENCES [dbo].[OKPD] ([LINK])
	ALTER TABLE [dbo].[NOMENCLATURE] NOCHECK CONSTRAINT [FK_NOMENCLATURE_OKPD]
	'
	EXEC SP_EXECUTESQL @Q 

	SET @Q = '
	IF  NOT EXISTS (SELECT * FROM dbo.sysconstraints WHERE constid =  object_id(''dbo.[FK_OKPD_OKPD]''))
	ALTER TABLE [dbo].[OKPD] WITH NOCHECK 
	ADD CONSTRAINT [FK_OKPD_OKPD] FOREIGN KEY ([LINK_SELF]) REFERENCES [dbo].[OKPD] ([LINK])
	ALTER TABLE [dbo].[OKPD] NOCHECK CONSTRAINT [FK_OKPD_OKPD]
	'
	EXEC SP_EXECUTESQL @Q 

	SET @Q = '
	EXECUTE dbo.X_UPDATE_DELETE_TRIGGERS
	'
	EXEC SP_EXECUTESQL @Q 

END
GO

/*******************************/

if exists (select * from dbo.sysobjects where id = object_id(N'OKPD_U') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	drop table [OKPD_U]
GO



EXECUTE dbo.VX_UPGRADE_CLEAR
GO

-- Declare @dbname sysname
--Select @dbname = db_name()
--exec sp_dboption @dbname, 'dbo use only', 'false'
--GO

WHILE @@TRANCOUNT > 0
	raiserror('@@TRANCOUNT>0!!!',11,1)
GO
